<!DOCTYPE html>
<?php

define('DEBUG_FILE_NAME', 'dealtHandler.log');

require 'baseFunctions.php';
require 'contact.php';
require 'deal.php';


function printArray($array){
    
    echo "<pre>";
    print_r($array);
    echo "</pre>";
    
    writeToLog($array, 'array');
    
}

function updateProcessed($id, $db, $obs = null){
    
    $query = "update requests set processed = 1, processed_time=CURRENT_TIMESTAMP(), obs = '".$obs."' where id = ".$id;
    
    printArray($query);
    
    $sql = $db->prepare($query);

    $sql->bindParam(":request", $json);
    $sql->bindParam(":method", $jsonDcd['method']);
    
    $sql->execute();
    
}

function getData($db){
    
    $dados = array();

    $sql = $db->prepare("SELECT * FROM requests r where r.processed = 0 and r.method <> 'contact' order by id limit 10");
    $sql->execute();
    
    $dados = $sql->fetchAll();
    
    return $dados;
}

/****************************************************************************************************************/


if(isset(AUTH["access_token"]) && AUTH["access_token"] != ""){
    printArray("ok");
}else{
    printArray("Bistrix24 APP desinstalado");
    exit();
}



require "conexao.php";


$dados = getData($db);

printArray($dados); 


$request = '';

foreach($dados as $key => $value){
    
    // sleep(3);
    
    if($value['method'] == 'deal'){
    
        $error = false;
        printArray($value); 
        
        $json = json_decode($value['request'], 1);
        if(isset($json['data_hora'])){             
            $json['data_hora'] = str_replace("+00", "+06", $json['data_hora']); //date('Y-m-d H:i:s', strtotime($json['data_hora'], "-6 hour"));
        }
        
        printArray($json);
       
        $deal = getDealByFilter($json['pedido_id']);
        
        if($deal['total'] == 0){
            
            $deal = getDealByFilterWoo($json['pedido_id']);
            
            if($deal['total'] == 0){
            
                $user = getContactByFilter($json['usuario_id']);
                
                printArray($user);
                // exit();
                
                if($user['total'] > 0){
                    
                    $dealId = addDeal($json, $user['result'][0]['ID']);
                    
                }else{
                    $user['result'][0]['ID'] = addContact($json, "deal");
                    
                    $dealId = addDeal($json, $user['result'][0]['ID']);
                    
                    printArray("Usuário não cadastrado");
                    // exit();
                }
            }else{
                $alterado = updDeal($deal['result'][0], $json);
                $dealId = $deal['result'][0]['ID'];
            }
            
            
        }else{
            $alterado = updDeal($deal['result'][0], $json);
            $dealId = $deal['result'][0]['ID'];
        }
        
        
        
        if($alterado)
            setProduct($dealId, $json['produtos']);
        
        if(!$error){
            
            updateProcessed($value['id'], $db);
            
        }
        
    }elseif($value['method'] == 'vaga'){
        
        $json = json_decode($value['request'], 1);
        if(isset($json['data_hora'])){
            $json['data_hora'] = str_replace("+00", "+06", $json['data_hora']); //date('Y-m-d H:i:s', strtotime($json['data_hora'], "-6 hour"));
        }
        
        if($request != $value['request']){

            $error = false;
            printArray($value);
            
            $deal = getDealByFilter($json['pedido_id']);
        
            updDealVaga($deal['result'][0]['ID'], $json);
                
            
            if(isset($json['pedido_id']) && $json['pedido_id'] != '' && isset($json['inscrito_id']) && $json['inscrito_id'] != ''){ // Na hora do Checkin
            
                printArray($value);
                
                $deal = getDealByFilterVaga($json);
                    
                updDealVagaChk($deal['result'][0]['ID'], $json);
                
                if(!$error){
                    
                    updateProcessed($value['id'], $db);
                    
                }
            }
            $request = $value['request'];
        }else{
            
            updateProcessed($value['id'], $db, "repetido");
            
            
        }
        
        
    }elseif($value['method'] == 'checkin'){
        
        $error = false;
        printArray($value); 
        
        $json = json_decode($value['request'], 1);
        if(isset($json['data_hora'])){             
            $json['data_hora'] = str_replace("+00", "+06", $json['data_hora']); //date('Y-m-d H:i:s', strtotime($json['data_hora'], "-6 hour"));
        }
        
        printArray($json);
       
        if(isset($json['pedido_id']) && $json['pedido_id'] != ''){
        
            $deal = getDealByFilter($json['pedido_id']);
        
            updDealCheck($deal['result'][0]['ID'], $json);
    
        }
        
        if(!$error){
            
            updateProcessed($value['id'], $db);
            
        }
        
        
    }elseif($value['method'] == 'exame'){
        
        $error = false;
        printArray($value); 
        
        $json = json_decode($value['request'], 1);
        if(isset($json['data_hora'])){             
            $json['data_hora'] = str_replace("+00", "+06", $json['data_hora']); //date('Y-m-d H:i:s', strtotime($json['data_hora'], "-6 hour")); 
        }
        
        printArray($json);
       
        if(isset($json['field_collection']) && $json['field_collection'] != ''){
            
            if($json['function'] == "insert"){
        
                $deal = getDealByFilterExam($json);
            
                updDealExamStart($deal['result'][0]['ID'], $json);
                
            }else{
                $error = true;
            }
    
        }elseif(isset($json['result_id']) && $json['result_id'] != ''){
        
            if($json['function'] == "update"){
            
                $deal = getDealByFilterResult($json['result_id']);
            
                updDealExamEnd($deal['result'][0], $json);
                
            }elseif($json['function'] == "correcao"){
            
                $deal = getDealByFilterCorrect($json['result_id']);
            
                updDealExamCoorect($deal['result'][0], $json);
                
            }elseif($json['function'] == "libera_certificado"){
            
                $deal = getDealByFilterCorrect($json['result_id']);
            
                updDealExamCerti($deal['result'][0], $json);
            }else{
                $error = true;
            }
        }else{
            $error = true;
        }
        
        if(!$error){
            
            updateProcessed($value['id'], $db);
            
        }
        
        
    }else{
        
        printArray("Não Entrou");
        
    }
    
    
    
}

?>