<?php

require('./src/config.php');
require('./src/cnx.php');

if($_REQUEST['tkn']!= TOKEN){
    writeToLog($_REQUEST, "Token inválido ".date('Y-m-d H:i:s'));
    header('Location: https://byte.bio');
    exit();
}else{
    $dados = file_get_contents("php://input");

    $json = json_decode($dados, 1);
    writeToLog($json, "INPUT ".date('Y-m-d H:i:s'));
    
    writeToLog($_REQUEST, "REQUEST ".date('Y-m-d H:i:s'));

}


/******************************************************/

$auth = getAuth($db);
if(!$auth){
    die("APP não Instalado!");
}

$requests = getRequestData($db, "order");

if(isset($requests[0]['id'])){

    if(isset($requests[0]['iniciados']) && $requests[0]['iniciados'] > 0){
        printArray("Existem processos não finalizados: ".$requests[0]['iniciados']);
        exit();
    }

    foreach($requests as $key => $request){
        
        printArray($request);
        
        $idProcessando = $request['id'];
        
        updateRequestQueue($request['id'], 1, $db);

        $data = json_decode($request['data'], 1);
        
        foreach($data['meta_data'] as $keyMd => $valueMd){
            
            $data['meta_data'][$valueMd['key']] = $valueMd['value'];
            
        }
        
        printArray($data);
        
        $contact = getContactId("24".$data['customer_id'], $auth, 1);
        
        if(isset($data['billing']['cpf']) && $data['billing']['cpf'] != ""){
            $cpfBusca = $data['billing']['cpf'];
        }elseif(isset($data['billing']['passaporte']) && $data['billing']['passaporte'] != ""){
            $cpfBusca = $data['billing']['passaporte'];
        }
        
        if(!isset($cpfBusca) || $cpfBusca == ''){
            echo "erro sem CPF";
            
            updateRequestQueue($request['id'], 3, $db);
            
            continue;
        }
        
        if(isset($contact['NAME']) && trim($contact['NAME']) != ''){
            
            $firstName = $contact['NAME'];
            $lastName  = $contact['LAST_NAME'];
        
        }elseif(isset($data['billing']['first_name']) && trim($data['billing']['first_name']) != ''){
            $firstName = $data['billing']['first_name'];
            $lastName  = $data['billing']['last_name'];
        }elseif(isset($data['meta_data']['{woocommerce_billing_first_name}']) && $data['meta_data']['{woocommerce_billing_first_name}'] != ''){
            $firstName = getNames($data['meta_data']['{woocommerce_billing_first_name}'], 0);
            $lastName  = getNames($data['meta_data']['{woocommerce_billing_first_name}'], 2);
        }
        
        $address = $data['billing'];

        $fields = array(
                    'NAME'                  => $firstName,
                    'LAST_NAME'             => $lastName,
                    "TYPE_ID"               => "CLIENT",
                    "ADDRESS"               => $address['address_1'].", ".$address['number']." ".$address['address_2'].", ".$address['neighborhood'].", ".$address['city']."/".$address['state'],
                    "UF_CRM_5EB94E418C162"  => $address['address_1'],
                    "UF_CRM_1643027746002"  => $address['number'],
                    'UF_CRM_1597844823179'  => $address['address_2'],
                    "UF_CRM_5EB94E419D72A"  => $address['neighborhood'],
                    "UF_CRM_5EB94E41ABB9F"  => $address['postcode'],
                    "UF_CRM_5EB94E41B300A"  => $address['city'],
                    "UF_CRM_5EB94E41BA1BF"  => getField('UF_CRM_5EB94E41BA1BF', $address['state'], 'contact', 0, MB_CASE_UPPER),
                    "UF_CRM_1672173391546"  => "24".$data['customer_id'],
                    "UF_CRM_1589202720035"  => $cpfBusca,
                    
                    
            );
        
        printArray($fields);
        
        if(isset($contact['ID']) && $contact['ID'] > 0){ //UPDATE
            
            if(isset($data['billing']['phone']) && trim($data['billing']['phone']) != ''){
                $fields['PHONE'] = phonesUpdate($contact['PHONE'], $data['billing']['phone']);
            }else{
                $fields['PHONE'] = $contact['PHONE'];
            }
            
            if(isset($data['billing']['cellphone']) && trim($data['billing']['cellphone']) != ''){
                $fields['PHONE'] = phonesUpdate($fields['PHONE'], $data['billing']['cellphone'], 'MOBILE');
            }

            $fields['EMAIL'] = phonesUpdate($contact['EMAIL'], $data['billing']['email'], 'WORK', 'EMAIL');
        
            printArray($fields);
            
            updateContact($fields, $contact['ID'], $auth, 1)['result'];
            
            
        }else{
            
            $oldPhones = array();
            $oldEmails = array();
            
            if(isset($data['billing']['phone']) && trim($data['billing']['phone']) != ''){
                $fields['PHONE'] = phonesUpdate($oldPhones, $data['billing']['phone']);
            }else{
                $fields['PHONE'] = $oldPhones;
            }
            
            if(isset($data['billing']['cellphone']) && trim($data['billing']['cellphone']) != ''){
                $fields['PHONE'] = phonesUpdate($fields['PHONE'], $data['billing']['cellphone'], 'MOBILE');
            }

            $fields['EMAIL'] = phonesUpdate($oldEmails, $data['email'], 'WORK', 'EMAIL');
        
            printArray($fields);
            
            $contact['ID'] = addContact($fields, $auth, 1)['result'];
            

        }
        
        $deal = getDeal($data['id'], $auth, 1);
        
        printArray($deal);
        
        $listaProdutos = array();
        foreach($data['line_items'] as $keyLi => $valueLi){
            
            $listaProdutos[] = $valueLi['name'];
            
            foreach($valueLi['meta_data'] as $keyLiMd => $valueLiMd){
            
                if($valueLiMd['key'] == 'pa_exame-area'){
                    $pa_exame_area = $valueLiMd['display_value'];
                }
                
                if($valueLiMd['key'] == 'pa_modalidade'){
                    $pa_modalidade = $valueLiMd['display_value'];
                }
                
                
                
            }
        }
        
        $listaProdutos = implode(", ", $listaProdutos);
        
        $fields = array(
                'UF_CRM_1708598380'     => $data['id'],
                'TITLE'                 => "Pedido ".$data['id'],
                "CATEGORY_ID" => 0, 
                'CONTACT_ID'            => $contact['ID'],
                'SOURCE_ID'             => "UC_S13KZR", // E-commerce
                
                'OPPORTUNITY'           => $data['total'], //number_format($data['total'], 2, ",", "")."|".$data['currency'],
                
                "UF_CRM_1626517884"     => getField('UF_CRM_1626517884', getStatus($data['status']),'deal'),
                
                "UF_CRM_1626606112239"  => getField('UF_CRM_1626606112239', $data['payment_method_title'],'deal'),
                
                'UF_CRM_1590676123198'  => $data['date_created'],
                'UF_CRM_1626519503600'  => $data['date_modified'],
                
                // 'UF_CRM_1680618653'     => $tipoProduto,
                // 'UF_CRM_1682593749'     => $produtosEcommerce,
                
                /* Simulado */
                // 'UF_CRM_1600102383'     => getField('UF_CRM_1600102383', $simuladoNome,'deal'),
                // 'UF_CRM_1626611815352'  => getField('UF_CRM_1600102383', 'Simulado','deal'),
                
                'UF_CRM_1682594330574'  => $data['total']-$data['shipping_total'],
                'UF_CRM_1650646909336'  => $data['shipping_total'], 
                
                "UF_CRM_1682594474299"  => getField('UF_CRM_1682594474299', $data['shipping_lines'][0]['method_title'],'deal'),
                
                "UF_CRM_1715861360366" => $listaProdutos,
                
                "UF_CRM_1626611826600" => getField('UF_CRM_1626611826600', $data['universidades']['nivel_exame'],'deal'),
                "UF_CRM_1622837970" => $data['universidades']['universidades'],
                "UF_CRM_1622837997" => $data['universidades']['programas_de_estudos'],
                "UF_CRM_1626611840125" => getField('UF_CRM_1626611840125', $pa_exame_area,'deal'),
                "UF_CRM_1626611815352" => getField('UF_CRM_1626611815352', $pa_modalidade,'deal'),
                
                "UF_CRM_1626615321496"  => getFileData($data['meta_data']['_wcuf_uploaded_files'], 'Envio (upload) de Documento'), // array("fileData" => array("dcto".time().".".$extDoct, base64_encode($docto))),
                "UF_CRM_1626615334197"  => getFileData($data['meta_data']['_wcuf_uploaded_files'], 'Envio (uploado) de selfie do documento*'), //array("fileData" => array("self".time().".".$extSelf, base64_encode($selfie))),

        );
        
        if(isset($deal['ID']) && $deal['ID'] > 0){
            
            updateDeal($fields, $deal['ID'], $auth, 1);
            
        }else{
            
            $deal['ID'] = addOrderBitrix($fields, $auth, 1)['result'];
            
        }

        updateRequestQueue($request['id'], 2, $db, $deal['ID']);

        // updateRequestQueue($request['id'], 0, $db);
        // exit();
        
    }
    
}else{
        
    $return = array('result' => 'success',
                    'msg' => 'EMPTY');
    
    $json = json_encode($return, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE );

    echo $json;
    
    
}
    