<?php

define('URL_BX', 'https://teseprime.bitrix24.com/rest/1/3m3l26107h6ri4s4/');
define('TKN', 'tg5gn06g68oy1vyxcgeamf0p4ob7uxpt');

header("Access-Control-Allow-Origin: *");
header('Cache-Control: no-cache, must-revalidate'); 
header("Content-Type: text/html; charset=UTF-8");
header("HTTP/1.1 200 OK");

date_default_timezone_set("America/Sao_Paulo");

writeToLog($_REQUEST, "Request entrada");

$data = file_get_contents('php://input'); 
$data = json_decode($data, 1);
writeToLog($data, "Body entrada");


if($_REQUEST['auth']['application_token'] != TKN && $_REQUEST['tkn'] != TKN){
    writeToLog($_REQUEST['auth']['application_token'], "Token Inválido");
    exit();
}

###########################################################################
########################## Auxlilary Functions ############################
###########################################################################

function pauseUs($time = 500000){
    usleep($time);
}

function writeToLog($data, $title = '')
{
// 	if (!DEBUG_FILE_NAME)
// 		return false;

// 	$log = "\n------------------------\n";
// 	$log .= date("Y.m.d G:i:s")."\n";
// 	$log .= (strlen($title) > 0 ? $title : 'DEBUG')."\n";
// 	$log .= print_r($data, 1);
// 	$log .= "\n------------------------\n";
	
// 	printArray($data);
// 	printArray($title);

// 	file_put_contents(__DIR__."/".DEBUG_FILE_NAME, $log, FILE_APPEND);
	return true;
}

function getJson($url, $array, $print = 1){
    
    $queryData = http_build_query($array);

    $curl = curl_init();
	curl_setopt_array($curl, array(
								CURLOPT_SSL_VERIFYPEER => 0,
								CURLOPT_POST => 1,
								CURLOPT_HEADER => 0,
								CURLOPT_RETURNTRANSFER => 1,							
								CURLOPT_URL => $url,
								CURLOPT_POSTFIELDS => $queryData,
								));
	$result = curl_exec($curl);
	curl_close($curl);

	$result = json_decode($result, 1);
	
	if (array_key_exists('error', $result)){

        echo "Error: ".$result['error_description']."<br/>";

        writeToLog("Error: ", $result);

    }
	
	if($print == 1){
	    printArray($url);
	    printArray($array);
	    printArray($result);
	    
	    writeToLog($url, "getJson");
	    writeToLog($array, "getJson");
	    writeToLog($result, "getJson");
	}
	
	pauseUs();

	return $result;
    
}

function notifyUser($message, $id_user, $print=0){

    $queryUrl = URL_BX."im.notify";
    
    $queryData = array(
                    "to" => $id_user,
                    "message" => $message,
                    "type" => "SYSTEM");
                    
    $result = getJson($queryUrl, $queryData, $print);       
}

function addFeed($id, $message, $entity, $print = 0){
    
// 1 - Lead;
// 2 - Deal;
// 3 - Contact;
// 4 - Company.
    
    $url = URL_BX.'crm.livefeedmessage.add';
    
    $array = array(
            "fields" => array(
                    "POST_TITLE" => "Feed Message",
                    "MESSAGE" => $message, 
                    "ENTITYTYPEID" => $entity,
                    "ENTITYID"=> $id,
                ),
        );
    
    $data = getJson($url, $array, $print);
    
}

// Chamada da função
// "UF_CRM_61EEF0C9C15A3"  => getField('UF_CRM_61EEF0C9C15A3', $dados['estado'], 'contact', 0, MB_CASE_UPPER), o MB_CASE_UPPER (TUDO MAIÚSCULO) - MB_CASE_TITLE (Primeia Letra Maiúscula)
function getField($field, $item, $entity, $print = 0, $case = MB_CASE_TITLE){
    
    $item = trim(mb_convert_case($item, $case, 'UTF-8'));
    
    if(trim($item) != ''){
    
        $queryUrl = URL_BX."crm.{$entity}.userfield.list";
    
        $array = array(
                "filter" => array(
                        "FIELD_NAME" => $field
                    )
            );
    
        $result = getJson($queryUrl, $array, $print);
        
        if(isset($result['result'][0]['LIST'][0]['ID'])){
            foreach($result['result'][0]['LIST'] as $key => $value){
                
                $itens[$key] = trim($value['VALUE']);
                $itensId[$key] = $value['ID'];
                        
            }
            $found = array_search(trim($item), $itens);
        }else{
            $found = false;
        }
        
        if($found === false){
    
            updateField($result['result'][0]['ID'], trim($item), $entity, $print);
            $newItem = getField($field,  trim($item), $entity, $print);
            
            return $newItem;
    
        }else{
    
            return $itensId[$found];
        }
    }else{
        // getField($field, 'Não Informado', $entity, $print);
        return "";
    }

}

function updateField($fieldId, $item, $entity, $print =0){
    
    $queryUrl = URL_BX."crm.{$entity}.userfield.update";
    
    $array = array(
            "ID" => $fieldId,
            "fields" => array(
                        "LIST" => array(array(
                                     "VALUE" => $item
                                    ))
                        ),
        );

    $result = getJson($queryUrl, $array, $print);
    sleep(2);
    
}

function printArray($array){
    echo "<pre>";
    print_r($array);
    echo "</pre>";
}

function formatDate($date){
    $newdate = date("Y-m-d", strtotime($date)).'T00:00:00+03:00';
    return $newdate;
}

function cleanDate($date){
    $newdate = date("d/m/Y", strtotime($date));
    return $newdate;
}

function getOnlyNumbers($var){
    return preg_replace("/[^0-9]/", "",$var);
}

function getInativo($value){
    
    if($value == '0'){
        return 'S';
    }elseif($value == '1'){
        return 'N';
    }else{
        return 'N';
    }
}

function getSimNao($value){
    
    if($value == 'S'){
        return 0;
    }elseif($value == 'N'){
        return 1;
    }else{
        return 1;
    }
}


function getTypeOmie($tags){
    
    foreach($tags as $key => $value){
        
        if($value['tag'] == 'Cliente'){
            
            return "CLIENT";
            
        }elseif($value['tag'] == 'Fornecedor'){
            
            return "SUPPLIER";
        }
        
        
    }
    
}

function getTagsType($type, $ce){
    
    if($type == 'CLIENT'){
        
        $return = array(array("tag" => 'Cliente'));
        
        
    }elseif($type == 'SUPPLIER'){
        
        $return = array(array("tag" => 'Fornecedor'));
        
        
    }
    
    return $return;
    
} 

function getData($data){
    
    // 2021-09-28T21:14:10+03:00
    
    $date = explode("T", $data);
    
    $hora = str_replace("+03:00", "", $date[1]);
    
    $hora = explode(":", $hora);
    $hr = $hora[0]-6;
    
    return $date[0]." ".$hr.":".$hora[1].":".$hora[2];
    
}

function getFieldValue($field, $item, $entity, $print = 0){
    
    $queryUrl = URL_BX."crm.{$entity}.userfield.list";

    $array = array(
            "filter" => array(
                    "FIELD_NAME" => $field
                )
        );

    $result = getJson($queryUrl, $array, $print);
    
    if(isset($result['result'][0]['LIST'][0]['ID'])){
        foreach($result['result'][0]['LIST'] as $key => $value){
            
            if($value['ID'] == $item){
                printArray($value['VALUE']); 
                return trim($value['VALUE']);
            }
                    
        }
    }else{
        printArray($item); 
        return $item;
    }

}



function getName($nome, $parte){

        $parts = array();
    
        while ( strlen( trim($nome)) > 0 ) {
            $nome = trim($nome);
            $string = preg_replace('#.*\s([\w-]*)$#', '$1', $nome);
            $parts[] = $string;
            $nome = trim( preg_replace('#'.$string.'#', '', $nome ) );
        }
    
        if (empty($parts)) {
            return false;
        }
    
        $parts = array_reverse($parts);
        $nome = array();
        $nome['first_name'] = $parts[0];
    
        $nome['middle_name'] = (isset($parts[2])) ? $parts[1] : '';
        $nome['last_name'] = (isset($parts[2])) ? $parts[2] : ( isset($parts[1]) ? $parts[1] : '');
    
        if($parte == 1){
    
            return reset($parts);
    
        }elseif($parte == 2){
            $middle = '';
    
            if(count($parts)>2){
    
                for ($i=1; $i <= count($parts)-2; $i++) { 
                    $middle = $middle." ".$parts[$i];
                }
                return $middle;
    
    
            }else{
                return '';
            }
    
        }elseif($parte == 3){
    
            return end($parts);
    
        }elseif($parte == 4){
            
            $middle = '';
    
            if(count($parts)>2){
    
                for ($i=1; $i <= count($parts)-2; $i++) { 
                    $middle = $middle." ".$parts[$i];
                }
                
                return $middle." ".end($parts);

            }else{
                return end($parts);
            }

        }else{
            return '';
        }
}

function adjustPhone($phone){
    
     writeToLog($phone, "OLD PHONES");
    
    if(!isset($phone) || $phone == ''){
        
        return '';
        
    }
    
    $phone = trim(preg_replace('/[^0-9]/', '', $phone));
    
    if(substr($phone, 0,1) != '+'){
       $phone = '+'.$phone;
    }
    
    if(strlen($phone) == 14 ){
        return $phone;
        
    }elseif(strlen($phone) == 13 ){
        
        if(substr($phone, 0,1) == '+'){
            
            if(substr($phone, 5,1) == '7' || substr($phone, 5,1) == '8' || substr($phone, 5,1) == '9'){
                
                return substr($phone, 0,5).'9'.substr($phone, 5);
                
            }else{
            
                return $phone;
                
            }
            
        }else{
            return '+'.$phone;
        }
        
    }elseif(strlen($phone) < 13 ){
        
        if(substr($phone, 0,3) != '+55'){
            
            
            
            $phone = str_replace("+", "", $phone);
            
            if(strlen($phone) == 11){
                
                return '+55'.$phone;
                
            }elseif(strlen($phone) < 11){
                if(substr($phone, 2,1) == '7' || substr($phone, 2,1) == '8' || substr($phone, 2,1) == '9'){
                    return '+55'.substr($phone, 0,2).'9'.substr($phone, 2);
                }else{
                    return '+55'.$phone;
                }
            }else{
            
                return $phone;
            
            }
        }else{
            
            return $phone;
            
        }
        
        
        
    }else{    
        return $phone;
    }
    
}

function phonesUpdate($oldPhones, $newPhone, $type = 'WORK', $phonEmail = 'PHONE'){
    
    writeToLog($oldPhones, "OLD PHONES");
    
    if(isset($newPhone) && $newPhone != ''){
        
        if($phonEmail == 'PHONE'){
    
            $found = false;
            foreach($oldPhones as $key => $value){
                if(adjustPhone($value['VALUE']) == adjustPhone($newPhone)){
                    $found = true; 
                    
                    $oldPhones[$key]['VALUE'] = adjustPhone($value['VALUE']);
                }else{
                    
                    $oldPhones[$key]['VALUE'] = adjustPhone($value['VALUE']);
                }
            }
            
            if($found == false){
                
                $oldPhones[] = array(
                                'VALUE_TYPE' => $type,
                                'VALUE'      => adjustPhone($newPhone)
                    );
                
            }
            
            return $oldPhones;
            
        }elseif($phonEmail == 'EMAIL'){
            
            $found = false;
            foreach($oldPhones as $key => $value){
                if($value['VALUE'] == validateEmail($newPhone)){
                    $found = true;        
                }
            }
            
            if($found == false){
                
                $oldPhones[] = array(
                                'VALUE_TYPE' => $type,
                                'VALUE'      => validateEmail($newPhone)
                    );
                
            }
            
            return $oldPhones;
            
        }else{
            
            $found = false;
            foreach($oldPhones as $key => $value){
                if($value['VALUE'] == $newPhone){
                    $found = true;        
                }
            }
            
            if($found == false){
                
                $oldPhones[] = array(
                                'VALUE_TYPE' => $type,
                                'VALUE'      => $newPhone
                    );
                
            }
            
            return $oldPhones;
            
        }
        
    }else{
        return $oldPhones;
    }
    
}

function validateEmail($email) {
    
    if(!filter_var($email, FILTER_VALIDATE_EMAIL) && trim($email) != '') {

        echo "E-mail ".$email." inválido";
        writeToLog("E-mail ".$email." inválido", "ERRO ".date('Y-m-d H:i:s'));

        return "";
    }else{
        return $email;
    }
}

function validar_cpf($cpf = false) {
    // Exemplo de CPF: 025.462.884-23

    /**
     * Multiplica dígitos vezes posições 
     *
     * @param string $digitos Os digitos desejados
     * @param int $posicoes A posição que vai iniciar a regressão
     * @param int $soma_digitos A soma das multiplicações entre posições e dígitos
     * @return int Os dígitos enviados concatenados com o último dígito
     *
     */
    if (!function_exists('calc_digitos_posicoes')) {
        function calc_digitos_posicoes($digitos, $posicoes = 10, $soma_digitos = 0) {
            // Faz a soma dos dígitos com a posição
            // Ex. para 10 posições: 
            //   0    2    5    4    6    2    8    8   4
            // x10   x9   x8   x7   x6   x5   x4   x3  x2
            //   0 + 18 + 40 + 28 + 36 + 10 + 32 + 24 + 8 = 196
            for ($i = 0; $i < strlen($digitos); $i++) {
                $soma_digitos = $soma_digitos + ($digitos[$i] * $posicoes);
                $posicoes--;
            }

            // Captura o resto da divisão entre $soma_digitos dividido por 11
            // Ex.: 196 % 11 = 9
            $soma_digitos = $soma_digitos % 11;

            // Verifica se $soma_digitos é menor que 2
            if ($soma_digitos < 2) {
                // $soma_digitos agora será zero
                $soma_digitos = 0;
            } else {
                // Se for maior que 2, o resultado é 11 menos $soma_digitos
                // Ex.: 11 - 9 = 2
                // Nosso dígito procurado é 2
                $soma_digitos = 11 - $soma_digitos;
            }

            // Concatena mais um dígito aos primeiro nove dígitos
            // Ex.: 025462884 + 2 = 0254628842
            $cpf = $digitos.$soma_digitos;

            // Retorna
            return $cpf;
        }
    }

    // Verifica se o CPF foi enviado
    if (!$cpf) {
        return false;
    }

    // Remove tudo que não é número do CPF
    // Ex.: 025.462.884-23 = 02546288423
    $cpf = preg_replace('/[^0-9]/is', '', $cpf);

    // Verifica se o CPF tem 11 caracteres
    // Ex.: 02546288423 = 11 números
    if (strlen($cpf) != 11) {
        return false;
    }

    // Captura os 9 primeiros dígitos do CPF
    // Ex.: 02546288423 = 025462884
    $digitos = substr($cpf, 0, 9);

    // Faz o cálculo dos 9 primeiros dígitos do CPF para obter o primeiro dígito
    $novo_cpf = calc_digitos_posicoes($digitos);

    // Faz o cálculo dos 10 dígitos do CPF para obter o último dígito
    $novo_cpf = calc_digitos_posicoes($novo_cpf, 11);

    // Verifica se o novo CPF gerado é idêntico ao CPF enviado
    if ($novo_cpf === $cpf) {
        // CPF válido
        return true;
    } else {
        // CPF inválido
        return false;
    }
}

function validar_cnpj($cnpj) {
    $cnpj = preg_replace('/[^0-9]/', '', (string) $cnpj);

    // Valida tamanho
    if (strlen($cnpj) != 14)
        return false;

    // Verifica se todos os digitos são iguais
    if (preg_match('/(\d)\1{13}/', $cnpj))
        return false;

    // Valida primeiro dígito verificador
    for ($i = 0, $j = 5, $soma = 0; $i < 12; $i++) {
        $soma += $cnpj[$i] * $j;
        $j = ($j == 2) ? 9 : $j - 1;
    }

    $resto = $soma % 11;

    if ($cnpj[12] != ($resto < 2 ? 0 : 11 - $resto))
        return false;

    // Valida segundo dígito verificador
    for ($i = 0, $j = 6, $soma = 0; $i < 13; $i++) {
        $soma += $cnpj[$i] * $j;
        $j = ($j == 2) ? 9 : $j - 1;
    }

    $resto = $soma % 11;

    return $cnpj[13] == ($resto < 2 ? 0 : 11 - $resto);
}

function formatar_cpf_cnpj($doc) {

    $doc = preg_replace("/[^0-9]/", "", $doc);
    $qtd = strlen($doc);

    if ($qtd >= 11) {

        if ($qtd === 11) {

            $docFormatado = substr($doc, 0, 3).
            '.'.
            substr($doc, 3, 3).
            '.'.
            substr($doc, 6, 3).
            '.'.
            substr($doc, 9, 2);
        } else {
            $docFormatado = substr($doc, 0, 2).
            '.'.
            substr($doc, 2, 3).
            '.'.
            substr($doc, 5, 3).
            '/'.
            substr($doc, 8, 4).
            '-'.
            substr($doc, -2);
        }

        return $docFormatado;

    } else {
        return 'Documento invalido';
    }
}

function checkTags($data){
    
    $posC = strpos($data['codigo_cliente_integracao'], 'C');
    $posE = strpos($data['codigo_cliente_integracao'], 'E');


    if(isset($data['codigo_cliente_integracao']) && $posC !== false){
        
        return 'Contato';
        
    }elseif(isset($data['codigo_cliente_integracao']) && $posE !== false){
        
        return 'Empresa';
        
    }else{
    
        if($data['pessoa_fisica'] == 'S'){
            return 'Contato';
        }elseif($data['pessoa_fisica'] == 'N'){
            return 'Empresa';
        }
    }
    
}


################################################################################
####################C CRM CONTACT FUNCTIONS ####################################

function getContactById($filter, $print = 0){
    
    if(isset($filter)){

        $queryUrl = URL_BX."crm.contact.list";
        
        $fields = Array(
            'filter' => array(
                    'ID' => trim($filter),
                ),
                'SELECT' => array('UF_*', '*', 'PHONE', 'EMAIL', 'WEB')
            );
            
        $result = getJson($queryUrl, $fields, $print);
        return $result;
    }else{
 
        return '';
        
    }
}

function contactName($contact){
    
    $name = explode(" ", $contact);
    $firstName = $name[0];
    
    for($i = 1; $i <= sizeof($name)-1; $i++){
        $lastName .= $name[$i]." ";
    }
    
    $name = Array(
        'firstName' => $firstName,
        'lastName'  => $lastName
    );
    
    return $name;
}

function getContactByFilter($filter, $print = 0){
    
    if(isset($filter)){

        $queryUrl = URL_BX."crm.contact.list";
        
        $fields = Array(
            'filter' => array(
                    '='.COD_CLIENTE_OMIE => trim($filter),
                ),
                'SELECT' => array('UF_*', '*', 'PHONE', 'EMAIL')
            );
            
        $result = getJson($queryUrl, $fields, $print)['result'][0];
        return $result;
    }else{
 
        return '';
        
    }
}

function updateContact($data, $oldId, $print = 0){
    
    $queryUrl = URL_BX."crm.contact.update";
    
    $fields = Array(
        'fields' => $data,
        'ID' => $oldId);
        
    $result = getJson($queryUrl, $fields, $print);
    return $result;

}

function addContact($data, $print = 0){
    
    $queryUrl = URL_BX."crm.contact.add";
    
    $fields = Array(
        'fields' => $data
        );
        
    $result = getJson($queryUrl, $fields, $print);
    return $result;

}